from .human_exit import Human_exitSideType, Human_exit

class SquareType:
    """Enum of square type"""
    WALL, HOUSE, CROSSROADS, STREET, ROAD, GRASS,  SIDEWALK, HUMAN_EXIT = range(8)

class Ground:
    """Ground class definition defined by :

    """

    def __init__(self, chapter_number): 
        """Ground constructor"""
        self.chapter_number = chapter_number
        self.nb_roads = 0
        self.nb_crossroads = 0
        self.squares = [[(SquareType.WALL) 
                       for y in xrange(50)]
                       for x in xrange(50)]
        self.human_exits = []

        #Blocks, Sidewalk, Roads & Crossroads disposal of each chapter
        if self.chapter_number = 1:
            self.nb_roads = 2
            self.nb_crossroads = 1
            self.nb_streets = 8
            self.road_disposal_horizontal(24)
            self.road_disposal_vertical(24)
            self.crossroads_disposal(24, 24)
            self.houses_blocks_disposal(False, True, True, False, 0, 0, 24, 24)
            self.houses_blocks_disposal(True, True, False, False, 26, 0, 24, 24)
            self.houses_blocks_disposal(False, False, True, True, 0, 26, 24, 24)
            self.houses_blocks_disposal(True, False, False, True, 26, 26, 24, 24)
            self.sidewalk_disposal_vertical(11, 23)
            self.sidewalk_disposal_horizontal(23, 16)
            self.sidewalk_disposal_vertical(29, 23)

        elif self.chapter_number = 2:
            self.nb_roads = 4
            self.nb_crossroads = 4
            self.nb_streets = 17
            self.road_disposal_horizontal(10)
            self.road_disposal_horizontal(43)
            self.road_disposal_vertical(18)
            self.road_disposal_vertical(48)
            self.crossroads_disposal(18, 10)
            self.crossroads_disposal(18, 43)
            self.crossroads_disposal(48, 10)
            self.crossroads_disposal(48, 43)
            self.houses_blocks_disposal(False, True, True, False, 0, 0, 18, 10)
            self.houses_blocks_disposal(True, True, True, False, 20, 0, 28, 10)
            self.houses_blocks_disposal(False, True, True, True, 0, 12, 18, 31)
            self.houses_blocks_disposal(True, True, True, True, 20, 12, 28, 31)
            self.houses_blocks_disposal(False, False, True, True, 0, 45, 18, 5)
            self.houses_blocks_disposal(True, False, True, True, 20, 45, 28, 5)
            self.sidewalk_disposal_vertical(9, 42)
            self.sidewalk_disposal_vertical(17, 4)
            self.sidewalk_disposal_vertical(17, 29)
            self.sidewalk_disposal_vertical(28, 42)
            self.sidewalk_disposal_vertical(36, 42)
            self.sidewalk_disposal_vertical(39, 9)

        elif self.chapter_number = 3:
            self.nb_roads = 6
            self.nb_crossroads = 9
            self.nb_streets = 16
            self.road_disposal_horizontal(0)
            self.road_disposal_horizontal(24)
            self.road_disposal_horizontal(48)
            self.road_disposal_vertical(0)
            self.road_disposal_vertical(24)
            self.road_disposal_vertical(48)
            self.crossroads_disposal(0, 0)
            self.crossroads_disposal(0, 24)
            self.crossroads_disposal(24, 0)
            self.crossroads_disposal(0, 48)
            self.crossroads_disposal(24, 24)
            self.crossroads_disposal(24, 48)
            self.crossroads_disposal(48, 24)
            self.crossroads_disposal(48, 0)
            self.crossroads_disposal(48, 48)
            self.houses_blocks_disposal(True, True, True, True, 2, 2, 22, 22)
            self.houses_blocks_disposal(True, True, True, True, 26, 2, 22, 22)
            self.houses_blocks_disposal(True, True, True, True, 2, 26, 22, 22)
            self.houses_blocks_disposal(True, True, True, True, 26, 26, 22, 22)
            self.sidewalk_disposal_vertical(12, 23)
            self.sidewalk_disposal_vertical(36, 23)
            self.sidewalk_disposal_horizontal(23, 12)
            self.sidewalk_disposal_horizontal(23, 36)

    #Squares types disposal methods : crossroads, roads, houses, streets, grasses & sidewalks

    def crossroads_disposal(self, x, y):
        self.squares[y][x] = SquareType.CROSSROADS # squares[y][x]
        self.squares[y][x + 1] = SquareType.CROSSROADS
        self.squares[y + 1][x] = SquareType.CROSSROADS
        self.squares[y + 1][x + 1] = SquareType.CROSSROADS

    def road_disposal_horizontal(self, y):
        for x in xrange(50):
            self.squares[y][x] = SquareType.ROAD
            self.squares[y + 1][x] = SquareType.ROAD
        self.human_exits.append(Human_exit(0, y, Human_exitSideType.LEFT))
        self.human_exits.append(Human_exit(0, y + 1, Human_exitSideType.LEFT))
        self.human_exits.append(Human_exit(49, y, Human_exitSideType.RIGHT))
        self.human_exits.append(Human_exit(49, y + 1, Human_exitSideType.RIGHT))

    def road_disposal_vertical(self, x):
        for y in xrange(50):
            self.squares[y][x] = SquareType.ROAD
            self.squares[y][x + 1] = SquareType.ROAD
        self.human_exits.append(Human_exit(x, 0, Human_exitSideType.DOWN))
        self.human_exits.append(Human_exit(x + 1, 0, Human_exitSideType.DOWN))
        self.human_exits.append(Human_exit(x, 49, Human_exitSideType.UP))
        self.human_exits.append(Human_exit(x + 1, 49, Human_exitSideType.UP))

    def house_disposal(self, x, y):
        for y in xrange(50):
            self.squares[y][x] = SquareType.HOUSE
            self.squares[y][x + 1] = SquareType.HOUSE
            self.squares[y][x + 2] = SquareType.HOUSE
            self.squares[y + 1][x] = SquareType.HOUSE
            self.squares[y + 2][x] = SquareType.HOUSE
            self.squares[y + 1][x + 1] = SquareType.HOUSE
            self.squares[y + 1][x + 2] = SquareType.HOUSE
            self.squares[y + 2][x + 1] = SquareType.HOUSE
            self.squares[y + 2][x + 2] = SquareType.HOUSE

    def street_disposal_horizontal(self, x_origin, y_origin, x_long):
        for x in xrange(x_long):
            self.squares[y_origin][x_origin + x] = SquareType.STREET

    def street_disposal_vertical(self, x_origin, y_origin, y_long):
        for y in xrange(y_long):
            self.squares[y_origin + y][x_origin] = SquareType.STREET

    def grass_disposal_horizontal(self, x_origin, y_origin, x_long):
        for x in xrange(x_long):
            self.squares[y_origin][x_origin + x] = SquareType.GRASS
            self.squares[y_origin + 1][x_origin + x] = SquareType.GRASS

    def grass_disposal_vertical(self, x_origin, y_origin, y_long):
        for y in xrange(y_long):
            self.squares[y_origin + y][x_origin] = SquareType.GRASS
            self.squares[y_origin + y][x_origin + 1] = SquareType.GRASS

    def sidewalk_disposal_horizontal(self, x_left, y_left):
        self.squares[y_left][x_left + 1] = SquareType.SIDEWALK
        self.squares[y_left][x_left + 2] = SquareType.SIDEWALK

    def sidewalk_disposal_vertical(self, x_down, y_down):
        self.squares[y_down + 1][x_down] = SquareType.SIDEWALK
        self.squares[y_down + 2][x_down] = SquareType.SIDEWALK

    #Houses blocks disposal : complex of houses blocks, streets, grasses & human exits disposal
    def houses_blocks_disposal(self, left_street, up_street, right_street, down_street, x_origin, y_origin, x_long, y_long):
        m = 0 # number of houses horizontally
        n = 0 # number of houses vertically
        k = 0 # number of streets+grasses horizontally
        l = 0 # number of streets+grasses vertically
        ls = 0 # 1 if left_street is True, 0 in opposite case
        ds = 0 # 1 if down_street is True, 0 in opposite case
        wall_x = x_long % 3
        wall_y = y_long % 3
        if left_street == True:
            k += 1
            ls += 1
        if right_street == True:
            k += 1
        if up_street == True:
            l += 1
        if down_street == True:
            l += 1
            ds += 1
        m = (x_long - (wall_x + k * 3)) / 3
        n = (y_long - (wall_y + l * 3)) / 3

        """if m = 1 and n = 1:
            house_disposal(x_origin, y_origin)
        elif m >= 2 and n = 1:
            for i in xrange(m):
                house_disposal(x_origin + 3 * i + 3 * ls, y_origin + 3 * ds)
        elif m = 1 and n >= 2:
            for i in xrange(n):
                house_disposal(x_origin + 3 * ls, y_origin + 3 * i + 3 * ds)
        elif m >= 2 and n >= 2:"""
        #Houses disposal
        if m >= 1 and n >= 1:
            for i in xrange(m):
                self.house_disposal(x_origin + 3 * i + 3 * ls, y_origin + 3 * ds)
                self.house_disposal(x_origin + 3 * i + 3 * ls, y_origin + ((n - 1) * 3) + 3 * ds)
            for i in xrange(n):
                self.house_disposal(x_origin + 3 * ls, y_origin + 3 * i + 3 * ds)
                self.house_disposal(x_origin + ((m - 1) * 3) + 3 * ls, y_origin + 3 * i + 3 * ds)
        if left_street == True:
            for i in xrange(m):
                self.house_disposal(x_origin + 3 * i + 3 * ls, y_origin + 3 * ds)
                self.house_disposal(x_origin + 3 * i + 3 * ls, y_origin + ((n - 1) * 3) + 3 * ds)
        #Streets & Grasses disposal
        if left_street == True:
            self.street_disposal_vertical(x_origin, y_origin, y_long)
            self.grass_disposal_vertical(x_origin + 1, y_origin + 1, y_long - 2)
        if right_street == True:
            self.street_disposal_vertical(x_origin + x_origin - 1, y_origin, y_long)
            self.grass_disposal_vertical(x_origin + x_origin - 3, y_origin + 1, y_long - 2)
        if up_street == True:
            self.street_disposal_horizontal(x_origin, y_origin + y_origin - 1, x_long)
            self.grass_disposal_horizontal(x_origin + 1, y_origin + y_origin - 3, x_long - 2)
        if down_street == True:
            self.street_disposal_horizontal(x_origin, y_origin, x_long)
            self.grass_disposal_horizontal(x_origin + 1, y_origin + 1, x_long - 2)



