#!/usr/bin/env python
# -*- coding: cp1252 -*-

import pyglet
import pyglet.text

class ImageLoader:
    def __init__(self):
        self.sprites = {}
    
    def sprite(self, name):
        (image, callback, resize) = self.sprites[name]
        self.sprites[name] = (image, callback, resize)
        
        sprite = pyglet.sprite.Sprite(image)
        sprite.scale = resize
        sprite.callback = callback
        return sprite

    def register(self, name, callback, size):
        image = pyglet.resource.image(name)
        width, height = size
        widthResized = width / float(image.width)
        heightResized = height / float(image.height)
        if widthResized > heightResized:
            resize = widthResized
        else:
            resize = heightResized
        self.sprites[name] = (image, callback, resize)
